%Author: Serge Shikher, Suffolk University.
%This program accompanies Shikher, S. "Capital, technology, and specialization in the neoclassical model".

%Xij is the vector of endogenous variables cij and Tij

function out=eqbase(Xij,alpha,beta,etaI,theta,B,w,d,X,Q,rw,N,J)

c=reshape(Xij(1:N*J,1),[N,J]); %transforming cost data into a 2-dimentional NxJ matrix
T=reshape(Xij(N*J+1:N*J*2,1),[N,J])./100; %transforming technology parameter data into a 2-dimentional NxJ matrix

%calculating prices and trade
D=repmat(shiftdim(T,-1),[N,1,1]).*(d.^(-theta));
p=(squeeze(sum(D.*repmat(shiftdim(c.^(-theta),-1),[N,1,1]),2))) .^ (-1/theta);
r=repmat(rw,[N,J]);
w=repmat(w,[1,J]);
pi=D.*(repmat(shiftdim(c.^(-theta),-1),[N,1,1])./repmat(reshape(p.^(-theta),[N,1,J]),[1,N,1]));

%calculating cost equation
coutmat=c-(w.^repmat(beta',[N,1])).*(r.^repmat(alpha',[N,1])).*...
    squeeze(prod(repmat(sum(D.*repmat(shiftdim(c.^(-theta),-1),[N,1,1]),2),[1,J,1]).^repmat(shiftdim(B,-1),[N,1,1]),3));

%calculating employment equation
Qoutmat=log(Q)-log(squeeze(sum(pi.*repmat(reshape(X,[N,1,J]),[1,N,1]),1)));

%packaging output vector
out=zeros(N*J*2,1);
out(1:N*J,1)=reshape(coutmat,[N*J,1]);
out(N*J+1:N*J*2,1)=reshape(Qoutmat,[N*J,1]);

